﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace TestProject
{
    public partial class StatsBox : Form
    {
        private List<int> alive = new List<int>();
        private List<int> alive1 = new List<int>();
        private List<int> alive2 = new List<int>();
        private List<int> alive3 = new List<int>();
        private List<int> alive4 = new List<int>();
        private int iterations = 0;
        private int alivetotal = 0;
        private int alive1total = 0;
        private int alive2total = 0;
        private int alive3total = 0;
        private int alive4total = 0;

        public StatsBox()
        {
            InitializeComponent();
        }
        public void statsUpdate(int a, int b, int c, int d, int e, bool running)
        {
            if (running == true)
            {
                iterations++;
                alivetotal = alivetotal + a;
                alive1total = alive1total + b;
                alive2total = alive2total + c;
                alive3total = alive3total + d;
                alive4total = alive4total + e;
                if (alive.Count <= 50)
                {
                    alive.Add(a);
                }
                else
                {
                    alive.RemoveAt(0);
                    alive.Add(a);
                }
                if (alive1.Count <= 50)
                {
                    alive1.Add(b);
                }
                else
                {
                    alive1.RemoveAt(0);
                    alive1.Add(b);
                }
                if (alive2.Count <= 50)
                {
                    alive2.Add(c);
                }
                else
                {
                    alive2.RemoveAt(0);
                    alive2.Add(c);
                }
                if (alive3.Count <= 50)
                {
                    alive3.Add(d);
                }
                else
                {
                    alive3.RemoveAt(0);
                    alive3.Add(d);
                }
                if (alive4.Count <= 50)
                {
                    alive4.Add(e);
                }
                else
                {
                    alive4.RemoveAt(0);
                    alive4.Add(e);
                }
                double aliveaverage = alivetotal / iterations;
                label1.Text = "Total Alive: " + Math.Round(aliveaverage,2);
                label2.Text = "Total Alive: " + a;
                label3.Text = "Total Alive: " + Math.Round(alive.Average(),2);
                double alive1average = alive1total / iterations;
                label4.Text = "Alive Type 1: " + b;
                label5.Text = "Alive Type 1: " + Math.Round(alive1average, 2);
                label6.Text = "Alive Type 1: " + Math.Round(alive1.Average(), 2);
                double alive2average = alive2total / iterations;
                label7.Text = "Alive Type 2: " + c;
                label8.Text = "Alive Type 2: " + Math.Round(alive2average, 2);
                label9.Text = "Alive Type 2: " + Math.Round(alive2.Average(), 2);
                double alive3average = alive3total / iterations;
                label10.Text = "Alive Type 3: " + d;
                label11.Text = "Alive Type 3: " + Math.Round(alive3average, 2);
                label12.Text = "Alive Type 3: " + Math.Round(alive3.Average(), 2);
                double alive4average = alive4total / iterations;
                label13.Text = "Alive Type 4: " + e;
                label14.Text = "Alive Type 4: " + Math.Round(alive4average, 2);
                label15.Text = "Alive Type 4: " + Math.Round(alive4.Average(), 2);
                pictureBox1.Refresh();
                pictureBox2.Refresh();
                pictureBox3.Refresh();
            }
        }
        public void resetstats()
        {
            iterations = 0;
            alivetotal = 0;
            alive1total = 0;
            alive2total = 0;
            alive3total = 0;
            alive4total = 0;
            alive.Clear();
            alive1.Clear();
            alive2.Clear();
            alive3.Clear();
            alive4.Clear();
            label1.Text = "Total Alive: ";
            label2.Text = "Total Alive: ";
            label3.Text = "Total Alive: ";
            label4.Text = "Alive Type 1: ";
            label5.Text = "Alive Type 1: ";
            label6.Text = "Alive Type 1: ";
            label7.Text = "Alive Type 2: ";
            label8.Text = "Alive Type 2: ";
            label9.Text = "Alive Type 2: ";
            label10.Text = "Alive Type 3: ";
            label11.Text = "Alive Type 3: ";
            label12.Text = "Alive Type 3: ";
            label13.Text = "Alive Type 4: ";
            label14.Text = "Alive Type 4: ";
            label15.Text = "Alive Type 4: ";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            resetstats();
        }

        private void StatsBox_Load(object sender, EventArgs e)
        {
            resetstats();
            this.Left = Screen.PrimaryScreen.Bounds.Width - this.Width;
            this.Top = (Screen.PrimaryScreen.Bounds.Height / 2) - (this.Height / 2);
        }

        private void StatsBox_Activated(object sender, EventArgs e)
        {
            this.Opacity = 100;
        }

        private void StatsBox_Deactivate(object sender, EventArgs e)
        {
            this.Opacity = 0.5;
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs f)
        {
            float b = 0;
            float c = 0;
            float d = 0;
            float e = 0;
            if (alive1.Count - 1 > 0)
            {
                b = alive1[alive1.Count - 1];
            }
            if (alive2.Count - 1 > 0)
            {
                c = alive2[alive2.Count - 1];
            }
            if (alive3.Count - 1 > 0)
            {
                d = alive3[alive3.Count - 1];
            }
            if (alive4.Count - 1 > 0)
            {
                e = alive4[alive4.Count - 1];
            }
            float a = b + c + d + e;
            if (a > 0)
            {
                float deg1 = (b / a) * 360;
                float deg2 = (c / a) * 360;
                float deg3 = (d / a) * 360;
                float deg4 = (e / a) * 360;
                Graphics g = f.Graphics;
                Pen p = new Pen(Color.Black, 1);
                Rectangle rec = new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height);


                Brush b1 = new SolidBrush(Color.Red);
                Brush b2 = new SolidBrush(Color.Blue);
                Brush b3 = new SolidBrush(Color.Green);
                Brush b4 = new SolidBrush(Color.Yellow);

                g.DrawPie(p, rec, 270, deg1);
                g.FillPie(b1, rec, 270, deg1);
                g.DrawPie(p, rec, deg1+270, deg2);
                g.FillPie(b2, rec, deg1+270, deg2);
                g.DrawPie(p, rec, deg2 + deg1+270, deg3);
                g.FillPie(b3, rec, deg2 + deg1+270, deg3);
                g.DrawPie(p, rec, deg3 + deg2 + deg1+270, deg4);
                g.FillPie(b4, rec, deg3 + deg2 + deg1+270, deg4);
            }
        }

        private void pictureBox2_Paint(object sender, PaintEventArgs f)
        {
            float b = 0;
            float c = 0;
            float d = 0;
            float e = 0;
            if (iterations > 0)
            {
                b = alive1total / iterations;
                c = alive2total / iterations;
                d = alive3total / iterations;
                e = alive4total / iterations;
            }
            float a = b + c + d + e;
            if (a > 0)
            {
                float deg1 = (b / a) * 360;
                float deg2 = (c / a) * 360;
                float deg3 = (d / a) * 360;
                float deg4 = (e / a) * 360;
                Graphics g = f.Graphics;
                Pen p = new Pen(Color.Black, 1);
                Rectangle rec = new Rectangle(0, 0, pictureBox2.Width, pictureBox2.Height);


                Brush b1 = new SolidBrush(Color.Red);
                Brush b2 = new SolidBrush(Color.Blue);
                Brush b3 = new SolidBrush(Color.Green);
                Brush b4 = new SolidBrush(Color.Yellow);

                g.DrawPie(p, rec, 270, deg1);
                g.FillPie(b1, rec, 270, deg1);
                g.DrawPie(p, rec, deg1 + 270, deg2);
                g.FillPie(b2, rec, deg1 + 270, deg2);
                g.DrawPie(p, rec, deg2 + deg1 + 270, deg3);
                g.FillPie(b3, rec, deg2 + deg1 + 270, deg3);
                g.DrawPie(p, rec, deg3 + deg2 + deg1 + 270, deg4);
                g.FillPie(b4, rec, deg3 + deg2 + deg1 + 270, deg4);
            }
        }

        private void pictureBox3_Paint(object sender, PaintEventArgs f)
        {
            float b = 0;
            float c = 0;
            float d = 0;
            float e = 0;
            if (alive1.Count - 1 > 0)
            {
                b = (float)alive1.Average();
            }
            if (alive2.Count - 1 > 0)
            {
                c = (float)alive2.Average();
            }
            if (alive3.Count - 1 > 0)
            {
                d = (float)alive3.Average();
            }
            if (alive4.Count - 1 > 0)
            {
                e = (float)alive4.Average();
            }
            float a = b + c + d + e;
            if (a > 0)
            {
                float deg1 = (b / a) * 360;
                float deg2 = (c / a) * 360;
                float deg3 = (d / a) * 360;
                float deg4 = (e / a) * 360;
                Graphics g = f.Graphics;
                Pen p = new Pen(Color.Black, 1);
                Rectangle rec = new Rectangle(0, 0, pictureBox3.Width, pictureBox3.Height);


                Brush b1 = new SolidBrush(Color.Red);
                Brush b2 = new SolidBrush(Color.Blue);
                Brush b3 = new SolidBrush(Color.Green);
                Brush b4 = new SolidBrush(Color.Yellow);

                g.DrawPie(p, rec, 270, deg1);
                g.FillPie(b1, rec, 270, deg1);
                g.DrawPie(p, rec, deg1 + 270, deg2);
                g.FillPie(b2, rec, deg1 + 270, deg2);
                g.DrawPie(p, rec, deg2 + deg1 + 270, deg3);
                g.FillPie(b3, rec, deg2 + deg1 + 270, deg3);
                g.DrawPie(p, rec, deg3 + deg2 + deg1 + 270, deg4);
                g.FillPie(b4, rec, deg3 + deg2 + deg1 + 270, deg4);
            }
        }
    }
}
